package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.SystemConfig;
import com.izouma.awesomeadmin.service.SystemConfigService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/systemConfig")
@RequiresAuthentication
public class SystemConfigController {

    @Autowired
    private SystemConfigService systemConfigService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(SystemConfig record) {
        List<SystemConfig> pp = systemConfigService.getSystemConfigList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getSystemConfig", method = RequestMethod.GET)
    @ResponseBody
    public Result getSystemConfig(@RequestParam(required = false, value = "id") String id) {
        SystemConfig data = systemConfigService.getSystemConfigById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(SystemConfig record) {
        SystemConfig data = systemConfigService.getSystemConfig(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, SystemConfig record) {
        Map<String, Object> result = new HashMap<>();

        List<SystemConfig> pp =systemConfigService.getSystemConfigByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(SystemConfig record) {
        boolean num = systemConfigService.createSystemConfig(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateSystemConfig(SystemConfig record) {
        boolean num = systemConfigService.updateSystemConfig(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteSystemConfig(SystemConfig record) {

        boolean num = systemConfigService.deleteSystemConfig(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, SystemConfig record) throws Exception {

    List<SystemConfig> systemConfigs = systemConfigService.getSystemConfigList(record);


        String sheetName = "system_config";
        String titleName = "系统配置数据表";
        String fileName = "系统配置表";
        int columnNumber = 12;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "订单比率" ,   "提现比率" ,   "预留字段" ,   "启用标识" ,   "个人押金" ,   "企业押金"  };
        String[][] dataList = new String[systemConfigs.size()][12];

        for (int i = 0; i < systemConfigs.size(); i++) {

                        dataList[i][0] = String.valueOf(systemConfigs.get(i).getId());
                        dataList[i][1] = String.valueOf(systemConfigs.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(systemConfigs.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(systemConfigs.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(systemConfigs.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(systemConfigs.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(systemConfigs.get(i).getOrderRate());
                        dataList[i][7] = String.valueOf(systemConfigs.get(i).getTixianRate());
                        dataList[i][8] = String.valueOf(systemConfigs.get(i).getExtra());
                        dataList[i][9] = String.valueOf(systemConfigs.get(i).getUseFlag());
                        dataList[i][10] = String.valueOf(systemConfigs.get(i).getPersonalDeposit());
                        dataList[i][11] = String.valueOf(systemConfigs.get(i).getCompanyDeposit());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

